<?php
ini_set('display_errors', 1);

require_once '../../../../resources/base_path_include.php';
//valdation file
require_once $base_path_to_resources . "includes/config.php"; // use require for mandatory files
require_once $base_path_to_resources . 'lib/function.php';
require_once $base_path_to_resources . "lib/currency_functions.php";
require_once $base_path_to_resources . 'lib/validate_api_signature.php';
require_once $base_path_to_resources . 'lib/validate_function.php';
require_once $base_path . 'user_management/authenticate.php';
//creating dynamic db
require_once $base_path_to_resources . 'includes/specific_db_config.php';
$postdata = json_decode(file_get_contents("php://input"), true);
checkIfNoPhpContentsReceive();

if (!isset($postdata['region_id']) or !checkIfIssetAndNotEmpty($postdata['region_id']) or !isset($postdata['company_id']) or !checkIfIssetAndNotEmpty($postdata['company_id']) or  !isset($postdata['branch_id']) or !checkIfIssetAndNotEmpty($postdata['branch_id']) or
!isset($postdata['book_id']) or !checkIfIssetAndNotEmpty($postdata['book_id']) or !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type']) or !isset($postdata['jwt_token']) or !checkIfIssetAndNotEmpty($postdata['jwt_token'])) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);
//authenticate jwt token
$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is decoded in data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$role = $jwt_validate->data->role;
$username = $jwt_validate->data->username;

// either the user has to fill gst or pan or ledgerhead 
function deleteRegionDetails($specific_db_conn, $region_id, $workspace_id, $company_id, $branch_id, $book_id)
{

    $sql = "Select region_id  from  inventory_stockbalances where region_id = ? and  workspace_id = ? and company_id =? and branch_id =? and book_id =? ";
    $stmt_region = $specific_db_conn->prepare($sql);
    $stmt_region->execute(array($region_id, $workspace_id, $company_id, $branch_id, $book_id));
    $fetch_region = $stmt_region->fetchAll();
    if (count($fetch_region) == 1) {
        $sql = "SELECT count(*) as total FROM inventory_stockbalances WHERE region_id = ? and workspace_id = ? and company_id =? and branch_id =? and book_id =? ";
        $stmt = $specific_db_conn->prepare($sql);
        $stmt->execute(array($region_id, $workspace_id, $company_id, $branch_id, $book_id));
        $act_groupinfo = $stmt->fetchAll();
        if ($act_groupinfo[0]['total'] >= 1) {

            errorreturn("Unable to delete region because of the presence of stock balances.");
        }
    } else {

        $sql = "DELETE FROM inventory_region_details WHERE id=? and workspace_id = ? and company_id =? and branch_id =? and book_id =?";
        $stmt = $specific_db_conn->prepare($sql);
        $stmt->execute(array($region_id, $workspace_id, $company_id, $branch_id, $book_id));
        $count = $stmt->rowCount();
        if ($count == 1) {
            return "Delete region Successfully";
        } else {
            errorreturn("unable to delete region");
        }
    }
}

if ($postdata['function_type']  == "delete_region") {

    $company_id = trim($postdata['company_id']);
    $branch_id = trim($postdata['branch_id']);
    $book_id = trim($postdata['book_id']);
    $region_id = trim($postdata['region_id']);
    $function_code = $postdata['function_type'];

     $confirmed_role_user = validatePrimaryAccess($conn, $workspace_id, $role, $userid, ['superadmin', 'admin', null]);
    if (!$confirmed_role_user){ 
        errorreturn('Access denied.');
    }else{
        $specific_db_conn = dynamicDbConnection($confirmed_role_user);
         if ($role == null) {
            checkCompanyBranchFunctionAccess($specific_db_conn, $role, $userid, $workspace_id, $company_id, $branch_id, $book_id,  $function_code);
         }
    }

    $success['data'] = deleteRegionDetails($specific_db_conn, $region_id, $workspace_id, $company_id, $branch_id, $book_id);
    successreturn($success);
}
